import 'package:flutter/material.dart';
import 'package:syncrow_web/utils/color_manager.dart';

class PowerClampEnergyDataDeviceDropdown extends StatelessWidget {
  const PowerClampEnergyDataDeviceDropdown({super.key});

  static final _color = ColorsManager.blackColor.withValues(alpha: 0.8);

  @override
  Widget build(BuildContext context) {
    return TextButton(
      style: TextButton.styleFrom(
        foregroundColor: _color,
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(16),
          side: const BorderSide(
            color: ColorsManager.greyColor,
            width: 1,
          ),
        ),
        backgroundColor: ColorsManager.transparentColor,
        padding: const EdgeInsets.symmetric(
          horizontal: 32,
          vertical: 16,
        ),
      ),
      child: const Text(
        'Device 1',
        style: TextStyle(
          fontWeight: FontWeight.w700,
        ),
      ),
      onPressed: () {},
    );
  }
}
