import 'package:syncrow_web/pages/analytics/models/phases_energy_consumption.dart';
import 'package:syncrow_web/pages/analytics/params/get_energy_consumption_by_phases_param.dart';
import 'package:syncrow_web/pages/analytics/services/energy_consumption_by_phases/energy_consumption_by_phases_service.dart';
import 'package:syncrow_web/services/api/http_service.dart';

final class RemoteEnergyConsumptionByPhasesService
    implements EnergyConsumptionByPhasesService {
  const RemoteEnergyConsumptionByPhasesService(this._httpService);

  final HTTPService _httpService;

  @override
  Future<List<PhasesEnergyConsumption>> load(
    GetEnergyConsumptionByPhasesParam param,
  ) async {
    try {
      final response = await _httpService.get(
        path: 'endpoint',
        showServerMessage: true,
        expectedResponseModel: (data) {
          final json = data as Map<String, dynamic>? ?? {};
          final mappedData = json['data'] as List<dynamic>? ?? [];
          return mappedData.map((e) {
            final jsonData = e as Map<String, dynamic>;
            return PhasesEnergyConsumption.fromJson(jsonData);
          }).toList();
        },
      );
      return response;
    } catch (e) {
      throw Exception('Failed to load energy consumption per device: $e');
    }
  }
}
