import 'package:syncrow_web/pages/analytics/models/device_energy_data_model.dart';
import 'package:syncrow_web/pages/analytics/params/get_energy_consumption_per_device_param.dart';
import 'package:syncrow_web/pages/analytics/services/energy_consumption_per_device/energy_consumption_per_device_service.dart';
import 'package:syncrow_web/services/api/http_service.dart';

class RemoteEnergyConsumptionPerDeviceService
    implements EnergyConsumptionPerDeviceService {
  const RemoteEnergyConsumptionPerDeviceService(this._httpService);

  final HTTPService _httpService;

  @override
  Future<List<DeviceEnergyDataModel>> load(
    GetEnergyConsumptionPerDeviceParam param,
  ) async {
    try {
      final response = await _httpService.get(
        path: 'endpoint',
        showServerMessage: true,
        expectedResponseModel: (data) {
          final json = data as Map<String, dynamic>? ?? {};
          final mappedData = json['data'] as List<dynamic>? ?? [];
          return mappedData.map((e) {
            final jsonData = e as Map<String, dynamic>;
            return DeviceEnergyDataModel.fromJson(jsonData);
          }).toList();
        },
      );
      return response;
    } catch (e) {
      throw Exception('Failed to load energy consumption per device: $e');
    }
  }
}
